//

datablock ParticleData(ChaosBeamExplosionParticle)
{
	dragCoefficient		= 1;
	gravityCoefficient	= 0;
	inheritedVelFactor	= 0.2;
	constantAcceleration = 0.0;
	lifetimeMS			  = 200;
	lifetimeVarianceMS	= 100;
	textureName			 = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;

	colors[0]	  = "1 0.25 0.25 0.9";
	colors[1]	  = "1 0.0 0.0 0.8";
	colors[2]	  = "1 0 0 0.6";
	colors[3]	  = "1 0 0 0.4";

	sizes[0]		= 0.1;
	sizes[1]		= 0.1;
	sizes[2]		= 0.15;
	sizes[3]		= 0.2;

	times[0] = 0.0;
	times[1] = 0.3;
	times[2] = 0.6;
	times[3] = 1.0;

	useInvAlpha = false;
};

datablock ParticleEmitterData(ChaosBeamExplosionEmitter)
{
	ejectionPeriodMS = 10;
	periodVarianceMS = 0;
	ejectionVelocity = 10;
	velocityVariance = 0.0;
	ejectionOffset	= 0.0;
	thetaMin			= 40;
	thetaMax			= 100;
	phiReferenceVel  = 0;
	phiVariance		= 360;
	overrideAdvance = false;
	particles = "ChaosBeamExplosionParticle";

	uiName = "Chaos Beam Explosion";
};

datablock ExplosionData(ChaosBeamExplosion)
{
	explosionShape = "";
	soundProfile = StormHitSound;

	lifeTimeMS = 100; //400

	particleEmitter = ChaosBeamExplosionEmitter;
	particleDensity = 200;
	particleRadius = 0.1;

	emitter[0] = ChaosBeamExplosionEmitter;

	//subExplosion[0] = "";
	//subExplosion[1] = ChaosBeamSubExplosion1;

	faceViewer	  = true;
	explosionScale = "0.1 0.1 0.1";

	shakeCamera = false;
	camShakeFreq = "1.0 11.0 10.0";
	camShakeAmp = "3.0 10.0 3.0";
	camShakeDuration = 0.5;
	camShakeRadius = 20.0;

	// Dynamic light
	lightStartRadius = 10;
	lightEndRadius = 20;
	lightStartColor = "1 0 0 1";
	lightEndColor = "1 0 0 0";

	damageRadius = 0;
	radiusDamage = 0;

	impulseRadius = 2;
	impulseForce = 1000;

	playerBurnTime = 0;
};

datablock ParticleData(ChaosBeamTrailParticle)
{
	dragCoefficient		= 0.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 300;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 0.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
	colors[0]	  = "1 0.25 0.25 1";
	colors[1]	  = "1 0.1 0.1 1";
	colors[2]	  = "1 0 0 1";
	colors[3]	  = "0.3 0.1 0.1 1";

	sizes[0]	= 0.4;
	sizes[1]	= 0.25;
	sizes[2]	= 0.1;
	sizes[3]	= 0.0;

	times[0]	= 0.2;
	times[1]	= 0.4;
	times[2]	= 0.5;
	times[3]	= 0.8;
};

datablock ParticleEmitterData(ChaosBeamTrailEmitter)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;

	ejectionVelocity = 0; //0.25;
	velocityVariance = 0; //0.10;

	ejectionOffset = 0;

	thetaMin			= 0.0;
	thetaMax			= 90.0;

	particles = ChaosBeamTrailParticle;

	useEmitterColors = true;
	uiName = "Chaos Beam Trail";
};

datablock ParticleData(ChaosBeamCTrailParticle)
{
	dragCoefficient		= 0.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 300;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 0.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
	colors[0]	  = "1 0.7 0.6 0.9";
	colors[1]	  = "1 0.36 0.13 0.8";
	colors[2]	  = "0.98 0.29 0 0.6";
	colors[3]	  = "0.98 0.29 0 0.4";

	sizes[0]	= 0.15;
	sizes[1]	= 0.1;
	sizes[2]	= 0.05;
	sizes[3]	= 0.0;

	times[0]	= 0.2;
	times[1]	= 0.4;
	times[2]	= 0.5;
	times[3]	= 0.8;
};

datablock ParticleEmitterData(ChaosBeamCTrailEmitter)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;

	ejectionVelocity = 0; //0.25;
	velocityVariance = 0; //0.10;

	ejectionOffset = 0;

	thetaMin			= 0.0;
	thetaMax			= 90.0;

	particles = ChaosBeamCTrailParticle;

	useEmitterColors = true;
	uiName = "Chaos Beam Charged Trail";
};

datablock StaticShapeData(ChaosSphereShape)
{
	shapeFile = "./BomberRedBullet.dts";
};

datablock fxLightData(ChaosSphereLight)
{
	lightRadius = 50;
	brightness  = 2;
	color  = "1 0 0 1";
	flareOn			= false;

	uiName = "Chaos Sphere Light";
};

datablock ParticleData(ChaosSphereExplosionParticle)
{
	dragCoefficient		= 1;
	gravityCoefficient	= 0;
	inheritedVelFactor	= 0.2;
	constantAcceleration = 0.0;
	lifetimeMS			  = 1010;
	lifetimeVarianceMS	= 400;
	textureName			 = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;

	colors[0]	  = "1 0.25 0.25 0.9";
	colors[1]	  = "1 0.1 0.1 0.8";
	colors[2]	  = "1 0 0 0.6";
	colors[3]	  = "1 0 0 0.4";

	sizes[0]		= 3.0;
	sizes[1]		= 4.0;
	sizes[2]		= 2.0;
	sizes[3]		= 3.5;

	times[0] = 0.0;
	times[1] = 0.3;
	times[2] = 0.6;
	times[3] = 1.0;

	useInvAlpha = false;
};

datablock ParticleEmitterData(ChaosSphereExplosionEmitter)
{
	ejectionPeriodMS = 3;
	periodVarianceMS = 0;
	ejectionVelocity = 5;
	velocityVariance = 1.0;
	ejectionOffset	= 3.0;
	thetaMin			= 0;
	thetaMax			= 40;
	phiReferenceVel  = 0;
	phiVariance		= 360;
	overrideAdvance = false;
	particles = "ChaosSphereExplosionParticle";

	uiName = "Chaos Sphere Explosion";
};

datablock ParticleData(ChaosSphereExplosionDotParticle)
{
	dragCoefficient		= 4;
	gravityCoefficient	= -0.0;
	inheritedVelFactor	= 0.2;
	constantAcceleration = 0.0;
	lifetimeMS			  = 500;
	lifetimeVarianceMS	= 100;
	textureName			 = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;

	colors[0]	  = "1 0.25 0.25 0.9";
	colors[1]	  = "1 0.1 0.1 0.8";
	colors[2]	  = "1 0 0 0.6";
	colors[3]	  = "1 0 0 0.4";

	sizes[0]		= 1.0;
	sizes[1]		= 1.5;
	sizes[2]		= 1.75;
	sizes[3]		= 1.25;

	times[0] = 0.0;
	times[1] = 0.3;
	times[2] = 0.6;
	times[3] = 1.0;

	useInvAlpha = false;
};

datablock ParticleEmitterData(ChaosSphereExplosionDotEmitter)
{
	lifeTimeMS = 100;

	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 20;
	velocityVariance = 10.0;
	ejectionOffset	= 0.0;
	thetaMin			= 0;
	thetaMax			= 180;
	phiReferenceVel  = 0;
	phiVariance		= 360;
	overrideAdvance = false;
	particles = "ChaosSphereExplosionDotParticle";

		uiName = "Chaos Sphere Explosion Dot";
};

datablock ParticleData(ChaosSphereExplosionRingParticle)
{
	dragCoefficient		= 4;
	gravityCoefficient	= -0.0;
	inheritedVelFactor	= 0.2;
	constantAcceleration = 0.0;
	lifetimeMS			  = 500;
	lifetimeVarianceMS	= 100;
	textureName			 = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;

	colors[0]	  = "1 0.25 0.25 0.9";
	colors[1]	  = "1 0.1 0.1 0.8";
	colors[2]	  = "1 0 0 0.6";
	colors[3]	  = "1 0 0 0.4";

	sizes[0]		= 1.0;
	sizes[1]		= 1.5;
	sizes[2]		= 2.0;
	sizes[3]		= 2.5;

	times[0] = 0.0;
	times[1] = 0.3;
	times[2] = 0.6;
	times[3] = 1.0;

	useInvAlpha = false;
};

datablock ParticleEmitterData(ChaosSphereExplosionRingEmitter)
{
	lifeTimeMS = 100;

	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 20;
	velocityVariance = 10.0;
	ejectionOffset	= 0.0;
	thetaMin			= 80;
	thetaMax			= 90;
	phiReferenceVel  = 0;
	phiVariance		= 360;
	overrideAdvance = false;
	particles = "ChaosSphereExplosionRingParticle";

		uiName = "Chaos Sphere Explosion Ring ";
};

datablock ParticleData(ChaosSphereExplosionChunkParticle)
{
	dragCoefficient		= 2;
	gravityCoefficient	= 0;
	inheritedVelFactor	= 0.2;
	constantAcceleration = 0.0;
	lifetimeMS			  = 500;
	lifetimeVarianceMS	= 400;
	textureName			 = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	colors[0]	  = "1 0.25 0.25 0.9";
	colors[1]	  = "1 0.1 0.1 0.8";
	colors[2]	  = "1 0 0 0.6";
	colors[3]	  = "1 0 0 0.4";
	sizes[0]		= 1.5;
	sizes[1]		= 2.0;
	sizes[2]		= 2.5;
	sizes[3]		= 3.0;
	times[0] = 0.0;
	times[1] = 0.5;
	times[2] = 1.0;
	times[3] = 1.5;

	useInvAlpha = false;
};

datablock ParticleEmitterData(ChaosSphereExplosionChunkEmitter)
{
	lifeTimeMS = 100;

	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 10;
	velocityVariance = 5.0;
	ejectionOffset	= 1.0;
	thetaMin			= 0;
	thetaMax			= 180;
	phiReferenceVel  = 0;
	phiVariance		= 360;
	overrideAdvance = false;
	particles = "ChaosSphereExplosionChunkParticle";

	uiName = "Chaos Sphere Explosion Chunk";
};

datablock ExplosionData(ChaosSphereExplosion)
{
	explosionShape = "";
	soundProfile = ChaosSphereExplosionSound;

	lifeTimeMS = 600;

	particleEmitter = ChaosSphereExplosionEmitter;
	particleDensity = 10;
	particleRadius = 0.5;

	emitter[0] = ChaosSphereExplosionChunkEmitter;
	emitter[1] = ChaosSphereExplosionRingEmitter;
	emitter[2] = ChaosSphereExplosionDotEmitter;

	//subExplosion[0] = "";
	//subExplosion[1] = ChaosBomberBlueSubExplosion1;

	faceViewer	  = true;
	explosionScale = "0.4 0.4 0.4";

	shakeCamera = false;
	camShakeFreq = "10.0 11.0 10.0";
	camShakeAmp = "3.0 10.0 3.0";
	camShakeDuration = 0.5;
	camShakeRadius = 20.0;

	// Dynamic light
	lightStartRadius = 15;
	lightEndRadius = 20;
	lightStartColor = "1 0 0 1";
	lightEndColor = "1 0 0 0";

	damageRadius = 8;
	radiusDamage = 50;

	impulseRadius = 10;
	impulseForce = 4000;

	playerBurnTime = 3000;
};

datablock ProjectileData(ChaosSphereChaosStuckProjectile)
{
	explosion			 	  = ChaosSphereExplosion;
	directDamage		  = 100;
	lifeTime = 100;
};

datablock ProjectileData(ChaosBeamProjectile)
{
	projectileShapeName = "";
	directDamage		  = 20;
	directDamageType	 = $DamageType::ChaosBeam;
	radiusDamageType	 = $DamageType::ChaosBeam;
	impactImpulse		 	= 800;
	verticalImpulse	  	= 800;
	explosion			 	  = ChaosBeamExplosion;
	particleEmitter	 	  = ChaosBeamTrailEmitter;

	brickExplosionRadius = 2;
	brickExplosionImpact = false;			 //destroy a brick if we hit it directly?
	brickExplosionForce  = 10;
	brickExplosionMaxVolume = 10;			 //max volume of bricks that we can destroy
	brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground

	muzzleVelocity		= 120;
	velInheritFactor	 = 1;

	armingDelay			= 0;
	lifetime				= 4000;
	fadeDelay			  = 6000;
	bounceElasticity	 = 0.5;
	bounceFriction		= 0.20;
	isBallistic			= true;
	gravityMod = 0;
	ProjectileScale = "1 1 1";

	hasLight	 = true;
	lightRadius = 20;
	lightColor  = "1 0 0 1";

	uiName = "Chaos Beam Projectile";
};

datablock ProjectileData(ChaosBeamCProjectile)
{
	projectileShapeName = "";
	directDamage		  = 75;
	directDamageType	 = $DamageType::ChaosBeam;
	radiusDamageType	 = $DamageType::ChaosBeam;
	impactImpulse		 	= 1000;
	verticalImpulse	  	= 800;
	explosion			 	  = ChaosBeamExplosion;
	particleEmitter	 	  = ChaosBeamCTrailParticle;

	brickExplosionRadius = 2;
	brickExplosionImpact = false;			 //destroy a brick if we hit it directly?
	brickExplosionForce  = 10;
	brickExplosionMaxVolume = 10;			 //max volume of bricks that we can destroy
	brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground

	muzzleVelocity		= 200;
	velInheritFactor	 = 1;

	armingDelay			= 0;
	lifetime				= 4000;
	fadeDelay			  = 6000;
	bounceElasticity	 = 0.5;
	bounceFriction		= 0.20;
	isBallistic			= true;
	gravityMod = 0;
	ProjectileScale = "1 1 1";

	hasLight	 = true;
	lightRadius = 20;
	lightColor  = "0.157 0.44 1 1";

	uiName = "Chaos Beam Charged Projectile";
};

datablock ProjectileData(ChaosSphereProjectile)
{
	projectileShapeName = "./BomberRedBullet.dts";
	directDamage		  = 40;
	directDamageType	 = $DamageType::ChaosSphere;
	radiusDamageType	 = $DamageType::ChaosSphere;
	impactImpulse		 	= 800;
	verticalImpulse	  	= 800;
	explosion			 	  = "";//ChaosBomberBlueExplosion;
	//particleEmitter	 	  = ChaosBomberBlueTrailEmitter;

	brickExplosionRadius = 2;
	brickExplosionImpact = false;			 //destroy a brick if we hit it directly?
	brickExplosionForce  = 10;
	brickExplosionMaxVolume = 10;			 //max volume of bricks that we can destroy
	brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground

	muzzleVelocity		= 120;
	velInheritFactor	 = 1;

	armingDelay			= 0;
	lifetime				= 2000;
	fadeDelay			  = 6000;
	bounceElasticity	 = 0.5;
	bounceFriction		= 0.20;
	isBallistic			= true;
	gravityMod = 0;
	ProjectileScale = "1 1 1";

	hasLight	 = true;
	lightRadius = 20;
	lightColor  = "1 0 0 1";

	//ui name removed
};

//////////
// item //
//////////

datablock ItemData(ChaosBeamItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./StormBlaster.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Chaos Beam";
	iconName = "./icon_StormBlaster";

	doColorShift = true;

	colorShiftColor = "1 0 0 1";

	 // Dynamic properties defined by the scripts
	image = ChaosBeamImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////

datablock ShapeBaseImageData(ChaosBeamImage)
{
	// Basic Item properties
	shapeFile = "./StormBlaster.dts";
	emap = true;

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0; //"0.7 1.2 -0.5";
	rotation = eulerToMatrix( "0 0 0" );

	// When firing from a point offset from the eye, muzzle correction
	// will adjust the muzzle vector to point to the eye LOS point.
	// Since this weapon doesn't actually fire from the muzzle point,
	// we need to turn this off.
	correctMuzzleVector = true;

	// Add the WeaponImage namespace as a parent, WeaponImage namespace
	// provides some hooks into the inventory system.
	className = "WeaponImage";

	// Projectile && Ammo.
	item = ChaosBeamItem;
	ammo = " ";
	projectile = ChaosBeamProjectile;
	projectileType = Projectile;

	//casing = ChaosBeamShellDebris;
	//shellExitDir		  = "1.0 -1.3 1.0";
	//shellExitOffset	  = "0 0 0";
	//shellExitVariance	= 15.0;
	//shellVelocity		 = 7.0;

	//melee particles shoot from eye node for consistancy
	melee = false;
	//raise your arm up or not
	armReady = true;
	minShotTime = 200;
	doColorShift = true;
	colorShiftColor = ChaosBeamItem.colorShiftColor;

	//casing = "";

	// Images have a state system which controls how the animations
	// are run, which sounds are played, script callbacks, etc. This
	// state system is downloaded to the client so that clients can
	// predict state changes and animate accordingly.  The following
	// system supports basic ready->fire->reload transitions as
	// well as a no-ammo->dryfire idle state.

	// Initial start up state
	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.2;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSequence[0]		= "ready";
	stateSound[0]				= BeamswitchSound;

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "FireA";
	stateAllowImageChange[1]	= true;

	stateName[2]			= "FireA";
	stateTransitionOnTimeout[2]	= "FireB";
	stateTimeoutValue[2]		= 0.1;
	stateTransitionOnTriggerUp[2]	= "Ready";
	stateFire[2]			= true;
	stateSequence[2]		= "fire";
	stateScript[2]			= "onFire";
	stateWaitForTimeout[2]		= true;
	stateAllowImageChange[2]	= false;
	stateSound[2]				= BeamFireSound;

	stateName[3]			= "FireB";
	stateTransitionOnTimeout[3]	= "FireC";
	stateTimeoutValue[3]		= 0.1;
	stateTransitionOnTriggerUp[3]	= "Ready";
	stateFire[3]			= true;
	stateSequence[3]		= "fire";
	stateScript[3]			= "onFire";
	stateWaitForTimeout[3]		= true;
	stateAllowImageChange[3]	= false;
	stateSound[3]				= BeamFireSound;

	stateName[4]			= "FireC";
	stateTransitionOnTimeout[4]	= "Charge";
	stateTimeoutValue[4]		= 0.1;
	StateTransitionOnTriggerUp[4]	= "Ready";
	stateFire[4]			= true;
	stateSequence[4]		= "fire";
	stateScript[4]			= "onFire";
	stateWaitForTimeout[4]		= true;
	stateAllowImageChange[4]	= false;
	stateSound[4]				= BeamFireSound;

	stateName[5]			= "Charge";
	stateTransitionOnTimeout[5]	= "Armed";
	stateTimeoutValue[5]		= 1.3;
	stateWaitForTimeout[5]		= False;
	stateTransitionOnTriggerUp[5]	= "AbortCharge";
	stateScript[5]			= "onCharge";
	stateAllowImageChange[5]	= false;
	stateSound[5]				= BeamchargestartAsound;

	stateName[6]			= "ChargeB";
	stateTransitionOnTimeout[6]	= "Armed";
	stateTimeoutValue[6]		= 0.7;
	stateWaitForTimeout[6]		= False;
	stateTransitionOnTriggerUp[6]	= "AbortCharge";
	stateScript[6]			= "onCharge";
	stateAllowImageChange[6]	= false;
	stateSound[6]				= BeamchargestartBsound;

	stateName[7]			= "AbortCharge";
	stateTransitionOnTimeout[7]	= "Ready";
	stateTimeoutValue[7]		= 0.1;
	stateWaitForTimeout[7]		= true;
	stateScript[7]			= "onAbortCharge";
	stateFire[7]			= true;
	stateSequence[7]		= "fire";
	stateScript[7]			= "onFire";
	stateAllowImageChange[7]	= false;
	stateSound[7]				= ChargebeamfireSound;

	stateName[8]			= "Armed";
	stateTransitionOnTriggerUp[8]	= "Firecharge";
	stateAllowImageChange[8]	= false;
	stateSound[8]				= Chargeloop;

	stateName[9]			= "Firecharge";
	stateTransitionOnTimeout[9]	= "Ready";
	stateTimeoutValue[9]		= 0.4;
	stateScript[9]			= "onChargeFire";
	stateFire[9]			= true;
	stateSequence[9]		= "fire";
	stateWaitForTimeout[9]		= true;
	stateAllowImageChange[9]	= false;
	stateSound[9]				= ChargebeamfireSound;

};

function ChaosBeamImage::onCharge(%this, %obj, %slot)
{
	%obj.playthread(2, shiftRight);
}

function ChaosBeamImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
	%projectile = ChaosBeamProjectile;
	%spread = 0.001;
	%obj.playThread(2, activate);

	%shellcount = 1;
	%obj.toolAmmo[%obj.currTool]--;

for(%shell=0; %shell<%shellcount; %shell++)
{
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
	%velocity = MatrixMulVector(%mat, %velocity);

	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	MissionCleanup.add(%p);
}
return %p;
}

function ChaosBeamImage::onChargeFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
	%projectile = ChaosBeamCProjectile;
	%spread = 0.001;
	%obj.playThread(2, activate);

	%shellcount = 1;
	%obj.toolAmmo[%obj.currTool]--;

for(%shell=0; %shell<%shellcount; %shell++)
{
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
	%velocity = MatrixMulVector(%mat, %velocity);

	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	MissionCleanup.add(%p);
}
return %p;
}

package ChaosSphere
{
	function Armor::onTrigger(%this, %player, %slot, %val)
	{
		echo("onTrigger");
		if(%slot == 4 && %val == true) //Checks if right mouse is clicked.
		{
			echo("Is Being Triggered");
			%image = %player.getMountedImage(0);
			if(%image == ChaosBeamImage.getID())
			{
				echo("Is Chaos Beam");
				if (!isObject(%bomb = %player.chaosBomb)) //Checks for a previous Bomb under the client's name.
				{
					echo("Chaos Bomb Exists");
					if ($Sim::Time - %player.lastBomberShotTime >= 2) // Checks if the the ability was fired last.
					{
						ServerPlay3d(ChaosBomberShotSound, %player.getPosition());
						echo("Firing Chaos Bomb");
						%p = new Projectile()
						{
							dataBlock       = ChaosSphereProjectile;
							initialPosition = %player.getMuzzlePoint(0);
							initialVelocity = vectorScale(%player.getMuzzleVector(0), 30);
							sourceObject    = %player;
							client          = %client;
							sourceSlot      = 0;
							originPoint     = %player.getMuzzlePoint(0);
							type 			= "Chaos";
						};
						MissionCleanup.add(%p);
						%player.chaosBomb = %p;

						schedule(1900, 0, SpawnBomberExplosion, %p, "Chaos");
						%p.schedule(1900, delete);

						%player.lastBomberShotTime = $Sim::Time;
					}
				}
				else
				{
					echo("Detonating Chaos Bomb");
					SpawnBomberExplosion(%bomb, "Chaos");
					%player.chaosBomb = "";
				}
			}
		}
		Parent::OnTrigger(%this, %player, %slot, %val);
	}
	function GameConnection::instantRespawn(%this)
	{
		if (isObject(%player = %this.player))
		{
			if (isObject(%bomb = %player.chaosBomb))
			{
				SpawnBomberExplosion(%bomb, %bomb.type);
				%bomb.delete();
				%player.chaosBomb = "";
			}
		}
		Parent::spawnPlayer(%this, %spawn);
	}

	function GameConnection::onDeath(%this, %obj, %killer, %type, %area)
	{
		if (isObject(%player = %this.player))
		{
			if (isObject(%bomb = %player.chaosBomb))
			{
				SpawnBomberExplosion(%bomb, %bomb.type);
				%player.chaosBomb = "";
			}
		}
		Parent::onDeath(%this, %obj, %killer, %type, %area);
	}

	function Armor::onRemove(%this, %obj)
	{
		//if (isObject(%player = %this.player))
		//{
			if (isObject(%bomb = %obj.chaosBomb))
			{
				SpawnBomberExplosion(%bomb, %bomb.type);
				%obj.chaosBomb = "";
			}
		//}
		Parent::onRemove(%this, %obj);
	}

	function fxDTSBrick::onBotDeath(%obj)
	{
		%bot = %obj.hBot;

		if (isObject(%bot))
		{
			if (isObject(%bomb = %bot.chaosBomb))
			{
				if(!(%bomb.getType() & $TypeMasks::ProjectileObjectType))
				{
					SpawnBomberExplosion(%obj, %bomb.type);
				}
			}
		}
		Parent::onBotDeath(%obj);
	}

	function fxDTSBrick::onDeath(%obj)
	{
		Parent::onDeath(%obj);

		if (%obj.chaosBombCount > 0)
		{
			for (%i = 0; %i < %obj.chaosBombCount; %i++)
			{
				%client = %obj.attachedChaosBomb[%i].client;
				%bomb = %obj.attachedChaosBomb[%i];

				SpawnBomberExplosion(%bomb, %bomb.type);
			}
		}
	}

	function fxDTSBrick::onRemove(%obj)
	{
		Parent::onRemove(%obj);

		if (isObject(%obj.chaosBombCount > 0))
		{
			for (%i = 0; %i < %obj.chaosBombCount; %i++)
			{
				%client = %obj.attachedChaosBomb[%i].client;
				%bomb = %obj.attachedChaosBomb[%i];

				SpawnBomberExplosion(%bomb, %bomb.type);
			}
		}
	}
};
activatePackage(ChaosSphere);

function ChaosSphereProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal)
{
	if (isObject(%source = %obj.sourceObject) && isObject(%source) && %source.getMountedImage(0) == ChaosBeamImage.getId() &&
		%col.getClassName() !$= "Player" && %col.getClassName() !$= "AiPlayer" &&
		%col.getClassName() !$= "Vehicle" && %col.getClassName() !$= "WheeledVehicle")
	{
		%light = new fxLight()
		{
			dataBlock = ChaosSphereLight;
			position = vectorAdd(%pos, "0 0 0.3");
		};
		MissionCleanup.add(%light);

		%p = new StaticShape()
		{
			dataBlock = ChaosSphereShape;
			position = %pos;
			type = "Chaos";
			objectAttachedTo = %col;
			client = %source.client;
			light = %light;
		};
		MissionCleanup.add(%p);

		if (%col.chaosBombCount $= "")
			%col.chaosBombCount = 0;

		%col.attachedChaosBomb[%col.chaosBombCount] = %p;
		%col.chaosBombCount++;

		if (isObject(%source))
			%source.chaosBomb = %p;

		%obj.delete();
	}
	else
	{
		%p = new Projectile()
		{
			dataBlock = ChaosSphereStuckProjectile;
			initialPosition = %pos;
			client = %source.client;
			sourceObject = %source.client;
		};
		MissionCleanup.add(%p);
		%p.explode();
	}
}

function ChaosBeamImage::onUnmount(%this, %obj, %slot)
{
	if (isObject(%bomb = %obj.chaosBomb))
	{
		SpawnBomberExplosion(%bomb, "Chaos");
		%obj.chaosBomb = "";
	}
}

function SpawnBomberExplosion(%obj, %type)
{
	if (!isObject(%obj))
		return;

	%p = new Projectile()
	{
		dataBlock = "ChaosSphere" @ %type @ "StuckProjectile";
		initialPosition = %obj.getPosition();
		client = %obj.sourceObject.client;
		sourceObject = %obj.client;
	};
	MissionCleanup.add(%p);
	%p.explode();

	%light = %obj.light;

	if (isObject(%light))
		%light.delete();

	if (isObject(%obj))
		%obj.delete();
}
